VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsQuery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Enums
'====================================================================================================
'-------------------------------------------------------------------|--------------------------------
Public Enum LISTVIEW_COLUMN                                         '
    colHost                                                         '
    colHostname                                                     '
    colAliases                                                      '
    colAddrType                                                     '
    colAddrLength                                                   '
    colAddrList                                                     '
End Enum                                                            '
'-------------------------------------------------------------------|--------------------------------
'====================================================================================================
'= Variables
'====================================================================================================
'-------------------------------------------------------------------|--------------------------------
Private WithEvents objHost                  As clsHost              '
Attribute objHost.VB_VarHelpID = -1
'|
Private strHost                             As String               '
Private blnInUse                            As Boolean              '
'-------------------------------------------------------------------|--------------------------------
'====================================================================================================
'= Public properties
'====================================================================================================
'----------------------------------------------------------------------------------------------------
'-----[ Property Host ]------------------------------------------------------------------------------
Private Property Get Host() As String
    Host = strHost
End Property
Private Property Let Host(strNewHost As String)
    strHost = strNewHost
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property InUse ]-----------------------------------------------------------------------------
Public Property Get InUse() As Boolean
    InUse = blnInUse
End Property
Private Property Let InUse(blnNewInUse As Boolean)
    blnInUse = blnNewInUse
End Property
'----------------------------------------------------------------------------------------------------



'####################################################################################################
'#####[ Class ]######################################################################################
'####################################################################################################
Private Sub Class_Initialize()
    Set objHost = New clsHost
End Sub

Private Sub Class_Terminate()
    Set objHost = Nothing
End Sub

Public Sub GetHostInfo(HostnameOrIP As String)
    Host = HostnameOrIP
    InUse = True
    '
    objHost.GetHostInfo HostnameOrIP
End Sub

'####################################################################################################
'#####[ Events ]#####################################################################################
'####################################################################################################
Private Sub objHost_HostResolved(ByVal Hostname As String, ByRef Aliases() As String, ByVal AddrType As String, ByVal AddrLength As Long, ByRef AddrList() As String)
    Dim sKey As String
    Dim lCol As Long
    '
    Debug.Print "Results for " & Host & ":"
    Debug.Print String$(Len("Results for " & Host & ":"), "")
    Debug.Print "HOSTENT.h_name               = " & Hostname               ' Hostname aus der HOSTENT Struktur
    Debug.Print "HOSTENT.h_aliases            = " & Join(Aliases(), "; ")  ' Alias Hostnamen aus der HOSTENT Struktur
    Debug.Print "HOSTENT.h_addrtype           = " & AddrType               ' Adress Type
    Debug.Print "HOSTENT.h_length             = " & CStr(AddrLength)       ' Lnger jeder Adresse in der Adress Liste
    Debug.Print "HOSTENT.h_addr_list          = " & Join(AddrList(), "; ") ' IP Adress Liste aus der HOSTENT Struktur
    Debug.Print "----------------------------------------------------------------------------"
    '
    sKey = "HOST_" & Host
    lCol = RGB(0, 128, 0)
    '
    With frmMain.lvwMain.ListItems(sKey)
        .ForeColor = lCol
        '
        .ListSubItems(colHostname).ForeColor = lCol
        .SubItems(colHostname) = Hostname
        '
        .ListSubItems(colAliases).ForeColor = lCol
        .SubItems(colAliases) = Join(Aliases(), "; ")
        '
        .ListSubItems(colAddrType).ForeColor = lCol
        .SubItems(colAddrType) = AddrType
        '
        .ListSubItems(colAddrLength).ForeColor = lCol
        .SubItems(colAddrLength) = CStr(AddrLength)
        '
        .ListSubItems(colAddrList).ForeColor = lCol
        .SubItems(colAddrList) = Join(AddrList(), "; ")
    End With
    '
    InUse = False
    Host = vbNullString
End Sub

Private Sub objHost_Error(ByVal Number As Integer, Description As String, ByVal Source As String)
    Dim sKey As String
    Dim lCol As Long
    '
    Debug.Print "Results for " & Host & ":"
    Debug.Print String$(Len("Results for " & Host & ":"), "")
    Debug.Print "Err.Number                   = " & CStr(Number)
    Debug.Print "Err.Description              = " & Description
    Debug.Print "Err.Source                   = " & Source
    Debug.Print "----------------------------------------------------------------------------"
    '
    sKey = "HOST_" & Host
    lCol = RGB(255, 0, 0)
    '
    With frmMain.lvwMain.ListItems(sKey)
        .ForeColor = lCol
        '
        .ListSubItems(colHostname).ForeColor = lCol
        .SubItems(colHostname) = "Fehler " & CStr(Number) & ": " & Description & " (Source: " & Source & ")"
        '
        .ListSubItems(colAliases).ForeColor = lCol
        .SubItems(colAliases) = ""
        '
        .ListSubItems(colAddrType).ForeColor = lCol
        .SubItems(colAddrType) = ""
        '
        .ListSubItems(colAddrLength).ForeColor = lCol
        .SubItems(colAddrLength) = ""
        '
        .ListSubItems(colAddrList).ForeColor = lCol
        .SubItems(colAddrList) = ""
    End With
    '
    InUse = False
    Host = vbNullString
End Sub
