VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHost"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= API's
'====================================================================================================
'----------------------------------------------------------------------------------------------------
'-----[ Memory Management Functions ]----------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Message and Message Queue Functions ]--------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Runtime Library Routines ]-------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, ByVal Source As Long, ByVal Length As Long)
'----------------------------------------------------------------------------------------------------
'-----[ String Manipulation Functions ]--------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Any) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Socket Functions ]---------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function inet_addr Lib "ws2_32" (ByVal cp As String) As Long
Private Declare Function inet_ntoa Lib "ws2_32" (ByVal inn As Long) As Long
Private Declare Function WSAAsyncGetHostByAddr Lib "ws2_32" (ByVal hWnd As Long, ByVal wMsg As Long, ByRef lngAddr As Long, ByVal lngLenght As Long, ByVal lngType As Long, buf As Any, ByVal lngBufLen As Long) As Long
Private Declare Function WSAAsyncGetHostByName Lib "ws2_32" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal strHostname As String, buf As Any, ByVal buflen As Long) As Long
Private Declare Function WSACleanup Lib "ws2_32" () As Long
Private Declare Function WSAStartup Lib "ws2_32" (ByVal wVersionRequested As Long, lpWsaData As WSADATA) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Window Functions ]---------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Window Procedure Functions ]-----------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Events
'====================================================================================================
'----------------------------------------------------------------------------------------------------
Public Event HostResolved(ByVal Hostname As String, ByRef Aliases() As String, ByVal AddrType As String, ByVal AddrLength As Long, ByRef AddrList() As String)
Public Event Error(ByVal Number As Integer, Description As String, ByVal Source As String)
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Const
'====================================================================================================
'---------------------------------------------------------------------------|------------------------
Private Const CLASS_NAME                    As String = "clsHost"           ' name of this class
'|
Private Const WSABASEERR                    As Long = 10000                 ' Winsock Base Error
'|
Private Const WSAEINTR                      As Long = (WSABASEERR + 4)      ' Windows Sockets definitions of regular Microsoft C error constants
Private Const WSAEBADF                      As Long = (WSABASEERR + 9)      '
Private Const WSAEACCES                     As Long = (WSABASEERR + 13)     '
Private Const WSAEFAULT                     As Long = (WSABASEERR + 14)     '
Private Const WSAEINVAL                     As Long = (WSABASEERR + 22)     '
Private Const WSAEMFILE                     As Long = (WSABASEERR + 24)     '
'|
Private Const WSAEWOULDBLOCK                As Long = (WSABASEERR + 35)     ' Windows Sockets definitions of regular Berkeley error constants
Private Const WSAEINPROGRESS                As Long = (WSABASEERR + 36)     '
Private Const WSAEALREADY                   As Long = (WSABASEERR + 37)     '
Private Const WSAENOTSOCK                   As Long = (WSABASEERR + 38)     '
Private Const WSAEDESTADDRREQ               As Long = (WSABASEERR + 39)     '
Private Const WSAEMSGSIZE                   As Long = (WSABASEERR + 40)     '
Private Const WSAEPROTOTYPE                 As Long = (WSABASEERR + 41)     '
Private Const WSAENOPROTOOPT                As Long = (WSABASEERR + 42)     '
Private Const WSAEPROTONOSUPPORT            As Long = (WSABASEERR + 43)     '
Private Const WSAESOCKTNOSUPPORT            As Long = (WSABASEERR + 44)     '
Private Const WSAEOPNOTSUPP                 As Long = (WSABASEERR + 45)     '
Private Const WSAEPFNOSUPPORT               As Long = (WSABASEERR + 46)     '
Private Const WSAEAFNOSUPPORT               As Long = (WSABASEERR + 47)     '
Private Const WSAEADDRINUSE                 As Long = (WSABASEERR + 48)     '
Private Const WSAEADDRNOTAVAIL              As Long = (WSABASEERR + 49)     '
Private Const WSAENETDOWN                   As Long = (WSABASEERR + 50)     '
Private Const WSAENETUNREACH                As Long = (WSABASEERR + 51)     '
Private Const WSAENETRESET                  As Long = (WSABASEERR + 52)     '
Private Const WSAECONNABORTED               As Long = (WSABASEERR + 53)     '
Private Const WSAECONNRESET                 As Long = (WSABASEERR + 54)     '
Private Const WSAENOBUFS                    As Long = (WSABASEERR + 55)     '
Private Const WSAEISCONN                    As Long = (WSABASEERR + 56)     '
Private Const WSAENOTCONN                   As Long = (WSABASEERR + 57)     '
Private Const WSAESHUTDOWN                  As Long = (WSABASEERR + 58)     '
Private Const WSAETOOMANYREFS               As Long = (WSABASEERR + 59)     '
Private Const WSAETIMEDOUT                  As Long = (WSABASEERR + 60)     '
Private Const WSAECONNREFUSED               As Long = (WSABASEERR + 61)     '
Private Const WSAELOOP                      As Long = (WSABASEERR + 62)     '
Private Const WSAENAMETOOLONG               As Long = (WSABASEERR + 63)     '
Private Const WSAEHOSTDOWN                  As Long = (WSABASEERR + 64)     '
Private Const WSAEHOSTUNREACH               As Long = (WSABASEERR + 65)     '
Private Const WSAENOTEMPTY                  As Long = (WSABASEERR + 66)     '
Private Const WSAEPROCLIM                   As Long = (WSABASEERR + 67)     '
Private Const WSAEUSERS                     As Long = (WSABASEERR + 68)     '
Private Const WSAEDQUOT                     As Long = (WSABASEERR + 69)     '
Private Const WSAESTALE                     As Long = (WSABASEERR + 70)     '
Private Const WSAEREMOTE                    As Long = (WSABASEERR + 71)     '
'|
Private Const WSASYSNOTREADY                As Long = (WSABASEERR + 91)     ' Extended Windows Sockets error constant definitions
Private Const WSAVERNOTSUPPORTED            As Long = (WSABASEERR + 92)     '
Private Const WSANOTINITIALISED             As Long = (WSABASEERR + 93)     '
Private Const WSAEDISCON                    As Long = (WSABASEERR + 101)    '
Private Const WSAENOMORE                    As Long = (WSABASEERR + 102)    '
Private Const WSAECANCELLED                 As Long = (WSABASEERR + 103)    '
Private Const WSAEINVALIDPROCTABLE          As Long = (WSABASEERR + 104)    '
Private Const WSAEINVALIDPROVIDER           As Long = (WSABASEERR + 105)    '
Private Const WSAEPROVIDERFAILEDINIT        As Long = (WSABASEERR + 106)    '
Private Const WSASYSCALLFAILURE             As Long = (WSABASEERR + 107)    '
Private Const WSASERVICE_NOT_FOUND          As Long = (WSABASEERR + 108)    '
Private Const WSATYPE_NOT_FOUND             As Long = (WSABASEERR + 109)    '
Private Const WSA_E_NO_MORE                 As Long = (WSABASEERR + 110)    '
Private Const WSA_E_CANCELLED               As Long = (WSABASEERR + 111)    '
Private Const WSAEREFUSED                   As Long = (WSABASEERR + 112)    '
'|
Private Const WSAHOST_NOT_FOUND             As Long = (WSABASEERR + 1001)   ' Authoritative Answer: Host not found
Private Const WSATRY_AGAIN                  As Long = (WSABASEERR + 1002)   ' Non-Authoritative: Host not found, or SERVERFAIL
Private Const WSANO_RECOVERY                As Long = (WSABASEERR + 1003)   ' Non recoverable errors, FORMERR, REFUSED, NOTIMP
Private Const WSANO_DATA                    As Long = (WSABASEERR + 1004)   ' Valid name, no data record of requested type
'|
Private Const AF_UNSPEC                     As Long = 0                     ' unspecified
Private Const AF_UNIX                       As Long = 1                     ' local to host (pipes, portals)
Private Const AF_INET                       As Long = 2                     ' internetwork: UDP, TCP, etc.
Private Const AF_IMPLINK                    As Long = 3                     ' arpanet imp addresses
Private Const AF_PUP                        As Long = 4                     ' pup protocols: e.g. BSP
Private Const AF_CHAOS                      As Long = 5                     ' mit CHAOS protocols
Private Const AF_NS                         As Long = 6                     ' XEROX NS protocols
Private Const AF_IPX                        As Long = AF_NS                 ' IPX protocols: IPX, SPX, etc.
Private Const AF_ISO                        As Long = 7                     ' ISO protocols
Private Const AF_OSI                        As Long = AF_ISO                ' OSI is ISO
Private Const AF_ECMA                       As Long = 8                     ' european computer manufacturers
Private Const AF_DATAKIT                    As Long = 9                     ' datakit protocols
Private Const AF_CCITT                      As Long = 10                    ' CCITT protocols, X.25 etc
Private Const AF_SNA                        As Long = 11                    ' IBM SNA
Private Const AF_DECnet                     As Long = 12                    ' DECnet
Private Const AF_DLI                        As Long = 13                    ' Direct data link interface
Private Const AF_LAT                        As Long = 14                    ' LAT
Private Const AF_HYLINK                     As Long = 15                    ' NSC Hyperchannel
Private Const AF_APPLETALK                  As Long = 16                    ' AppleTalk
Private Const AF_NETBIOS                    As Long = 17                    ' NetBios-style addresses
Private Const AF_VOICEVIEW                  As Long = 18                    ' VoiceView
Private Const AF_FIREFOX                    As Long = 19                    ' Protocols from Firefox
Private Const AF_UNKNOWN1                   As Long = 20                    ' Somebody is using this!
Private Const AF_BAN                        As Long = 21                    ' Banyan
Private Const AF_ATM                        As Long = 22                    ' Native ATM Services
Private Const AF_INET6                      As Long = 23                    ' Internetwork Version 6
Private Const AF_CLUSTER                    As Long = 24                    ' Microsoft Wolfpack
Private Const AF_12844                      As Long = 25                    ' IEEE 1284.4 WG AF
'|
Private Const WS_VERSION_MINOR              As Long = &H1&                  '
Private Const WS_VERSION_MAJOR              As Long = &H100&                '
Private Const WS_VERSION_REQD               As Long = WS_VERSION_MINOR Or WS_VERSION_MAJOR
'|
Private Const WSADESCRIPTION_LEN            As Long = 256                   ' WSADATA.szDescription length
Private Const WSASYS_STATUS_LEN             As Long = 128                   ' WSADATA.szSystemStatus length
'|
Private Const MAXGETHOSTSTRUCT              As Long = 1024                  ' Define constant based on rfc883, used by gethostbyxxxx() calls.
Private Const INADDR_NONE                   As Long = &HFFFFFFFF            '
'|
Private Const GMEM_FIXED                    As Long = &H0                   ' Allocates fixed memory. The return value is a pointer.
'|
Private Const GWL_WNDPROC                   As Long = &HFFFFFFFC            ' Sets a new address for the window procedure.
'---------------------------------------------------------------------------|------------------------
'====================================================================================================
'= Types
'====================================================================================================
'---------------------------------------------------------------------------|------------------------
Private Type WSADATA                                                        ' The WSADATA structure is used to store Windows Sockets initialization information returned by a call to the WSAStartup global function.
    wVersion                                As Integer                      ' The version of the Windows Sockets specification that the WS2_32.DLL expects the caller to use.
    wHighVersion                            As Integer                      ' The highest version of the Windows Sockets specification that this DLL can support (also encoded as above). Normally this will be the same as wVersion.
    szDescription(0 To WSADESCRIPTION_LEN)  As Byte                         ' A null-terminated ASCII string into which the WS2_32.DLL copies a description of the Windows Sockets implementation. The text (up to 256 characters in length) can contain any characters except control and formatting characters: the most likely use that an application will put this to is to display it (possibly truncated) in a status message.
    szSystemStatus(0 To WSASYS_STATUS_LEN)  As Byte                         ' A null-terminated ASCII string into which the WS2_32.DLL copies relevant status or configuration information. The WS2_32.DLL should use this field only if the information might be useful to the user or support staff: it should not be considered as an extension of the szDescription field.
    iMaxSockets                             As Integer                      ' This field is retained for backward compatibility, but should be ignored for version 2 and later as no single value can be appropriate for all underlying service providers.
    iMaxUdpDg                               As Integer                      ' This value should be ignored for version 2 and onward. It is retained for compatibility with Windows Sockets specification 1.1, but should not be used when developing new applications. For the actual maximum message size specific to a particular Windows Sockets service provider and socket type, applications should use getsockopt to retrieve the value of option SO_MAX_MSG_SIZE after a socket has been created.
    lpVendorInfo                            As Long                         ' This value should be ignored for version 2 and onward. It is retained for compatibility with Windows Sockets specification 1.1. Applications needing to access vendor-specific configuration information should use getsockopt to retrieve the value of option PVD_CONFIG. The definition of this value (if utilized) is beyond the scope of this specification. Note An application should ignore the iMaxsockets, iMaxUdpDg, and lpVendorInfo fields in WSADATA if the value in wVersion after a successful call to WSAStartup is at least 2. This is because the architecture of Windows Sockets has been changed in version 2 to support multiple providers, and WSADATA no longer applies to a single vendor's stack. Two new socket options are introduced to supply provider-specific information: SO_MAX_MSG_SIZE (replaces the iMaxUdpDg element) and PVD_CONFIG (allows any other provider-specific configuration to occur).
End Type                                                                    '
'|
Private Type HOSTENT                                                        ' The hostent structure is used by functions to store information about a given host, such as host name, IP address, and so forth. An application should never attempt to modify this structure or to free any of its components. Furthermore, only one copy of the hostent structure is allocated per thread, and an application should therefore copy any information that it needs before issuing any other Windows Sockets API calls.
    h_name                                  As Long                         ' Official name of the host (PC). If using the DNS or similar resolution system, it is the Fully Qualified Domain Name (FQDN) that caused the server to return a reply. If using a local hosts file, it is the first entry after the IP address.
    h_aliases                               As Long                         ' Null-terminated array of alternate names.
    h_addrtype                              As Integer                      ' Type of address being returned.
    h_length                                As Integer                      ' Length of each address, in bytes.
    h_addr_list                             As Long                         ' Null-terminated list of addresses for the host. Addresses are returned in network byte order. The macro h_addr is defined to be h_addr_list[0] for compatibility with older software.
End Type                                                                    '
'---------------------------------------------------------------------------|------------------------
'====================================================================================================
'= Variables
'====================================================================================================
'---------------------------------------------------------------------------|------------------------
Private lngWindowHandle                     As Long                         ' socket window handle
Private lngOldWindowProc                    As Long                         ' old WindowProc
Private lngRequestID                        As Long                         ' WSAAsyncGetHostBy Addr/Name requets id
Private lngMemoryHandle                     As Long                         ' handle of the allocated memory block object
Private lngMemoryPointer                    As Long                         ' address of the memory block
'---------------------------------------------------------------------------|------------------------
'----------------------------------------------------------------------------------------------------



'####################################################################################################
'#####[ Class ]######################################################################################
'####################################################################################################
Private Sub Class_Initialize()
    If modWinsock.blnWinsockInit = False Then
        Dim lpWsaData As WSADATA
        Dim lngReturn As Long
        '
        lngReturn = WSAStartup(WS_VERSION_REQD, lpWsaData)
        If lngReturn = 0 Then
            If modWinsock.lngResolveMessage = 0 Then
                modWinsock.lngResolveMessage = RegisterWindowMessage("WSA.ResolveMessage")
                '
                Debug.Print "WSADATA.wVersion             = " & Format(HiByte(lpWsaData.wVersion), "####0") & "." & Format(LoByte(lpWsaData.wVersion), "####0")
                Debug.Print "WSADATA.wHighVersion         = " & Format(HiByte(lpWsaData.wHighVersion), "####0") & "." & Format(LoByte(lpWsaData.wHighVersion), "####0")
                Debug.Print "WSADATA.szDescription        = " & StripNull(StrConv(lpWsaData.szDescription(), vbUnicode))
                Debug.Print "WSADATA.szSystemStatus       = " & StripNull(StrConv(lpWsaData.szSystemStatus(), vbUnicode))
                Debug.Print "WSADATA.iMaxSockets          = " & Format(lpWsaData.iMaxSockets, "###,###,###,##0")
                Debug.Print "WSADATA.iMaxUdpDg            = " & Format(lpWsaData.iMaxUdpDg And &HFF&, "###,###,###,##0")
                Debug.Print "WSADATA.lpVendorInfo         = " & Format(lpWsaData.lpVendorInfo, "###,###,###,##0")
                Debug.Print "----------------------------------------------------------------------------"
                '
                Debug.Print "modWinsock.lngResolveMessage = " & CStr(modWinsock.lngResolveMessage)
                Debug.Print "----------------------------------------------------------------------------"
                '
            End If
            modWinsock.blnWinsockInit = True
        Else
            Err.Raise 2001, CLASS_NAME, "Die Funktion WSAStartup() ist fehlgeschlagen."
            Exit Sub
        End If
    End If
    '
    If modWinsock.blnWinsockInit = True Then
        lngWindowHandle = CreateWindowEx(0&, "STATIC", "SOCKET_WINDOW", 0&, 0&, 0&, 0&, 0&, 0&, 0&, App.hInstance, ByVal 0&)
        '
        Debug.Print "lngWindowHandle              = " & CStr(lngWindowHandle)
        '
        If lngWindowHandle = 0 Then
            Err.Raise 2002, CLASS_NAME, "Die Funktion CreateWindowEx() ist fehlgeschlagen."
            Exit Sub
        End If
        '
        lngOldWindowProc = SetWindowLong(lngWindowHandle, GWL_WNDPROC, AddressOf modWinsock.WindowProc)
        '
        Debug.Print "lngOldWindowProc             = " & CStr(lngOldWindowProc)
        Debug.Print "----------------------------------------------------------------------------"
        '
        If lngOldWindowProc = 0 Then
            Err.Raise 2003, CLASS_NAME, "Die Funktion SetWindowLong() ist fehlgeschlagen."
            Exit Sub
        End If
    End If
    '
    modWinsock.colHost.Add Me, "HWND_" & CStr(lngWindowHandle)
End Sub

Private Sub Class_Terminate()
    Dim lngReturn As Long
    Dim i         As Long
    '
    If lngWindowHandle <> 0 Then
        If lngOldWindowProc <> 0 Then
            lngReturn = SetWindowLong(lngWindowHandle, GWL_WNDPROC, lngOldWindowProc)
            lngOldWindowProc = 0
        End If
        '
        lngReturn = DestroyWindow(lngWindowHandle)
        lngWindowHandle = 0
    End If
    '
    For i = 1 To modWinsock.colHost.Count
        If modWinsock.colHost(i) Is Me Then
            modWinsock.colHost.Remove i
            Exit For
        End If
    Next i
    '
    If ((modWinsock.blnWinsockInit = True) And (modWinsock.colHost.Count = 0)) Then
        lngReturn = WSACleanup()
        '
        modWinsock.blnWinsockInit = False
    End If
End Sub

'####################################################################################################
'#####[ GetHostInfo ]################################################################################
'####################################################################################################
Public Sub GetHostInfo(HostnameOrIP As String)
    Dim lngAddr As Long
    '
    lngMemoryHandle = GlobalAlloc(GMEM_FIXED, MAXGETHOSTSTRUCT)
    If lngMemoryHandle > 0 Then
        lngMemoryPointer = GlobalLock(lngMemoryHandle)
        If lngMemoryPointer <> 0 Then   'Unlock the memory block
            GlobalUnlock (lngMemoryHandle)
        Else                            'Memory allocation error
            Call GlobalFree(lngMemoryHandle)
            Err.Raise 2005, CLASS_NAME, "Die Funktion GlobalLock() ist fehlgeschlagen."
            Exit Sub
        End If
    Else                                'Memory allocation error
        Err.Raise 2004, CLASS_NAME, "Die Funktion GlobalAlloc() ist fehlgeschlagen."
        Exit Sub
    End If
    '
    lngAddr = inet_addr(HostnameOrIP)
    '
    If lngAddr = INADDR_NONE Then
        lngRequestID = WSAAsyncGetHostByName(lngWindowHandle, modWinsock.lngResolveMessage, HostnameOrIP, ByVal lngMemoryPointer, MAXGETHOSTSTRUCT)
    Else
        lngRequestID = WSAAsyncGetHostByAddr(lngWindowHandle, modWinsock.lngResolveMessage, lngAddr, 4&, AF_INET, ByVal lngMemoryPointer, MAXGETHOSTSTRUCT)
    End If
    '
    Debug.Print "lngRequestID                 = " & CStr(lngRequestID)
    Debug.Print "----------------------------------------------------------------------------"
    '
End Sub

'####################################################################################################
'#####[ IncommingMessage ]###########################################################################
'####################################################################################################
Public Function IncommingMessage(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Attribute IncommingMessage.VB_MemberFlags = "40"
    Dim udtHostent       As HOSTENT                                 ' HOSTENT struct
    Dim strHostname      As String                                  ' resolved hostname
    Dim strAddrType      As String                                  ' address type
    Dim lngAddrLength    As Long                                    ' address length
    Dim strAliases()     As String                                  ' list of alternate hostnames (if any)
    Dim lngAliasesCount  As Long                                    ' count of alternate hostnames
    Dim lngAliasesPtr    As Long                                    ' pointer to an alternate hostname
    Dim strAddrList()    As String                                  ' list of ip addresses for the host
    Dim lngAddrListCount As Long                                    ' count of ip addresses for the host
    Dim lngAddrListPtr   As Long                                    ' pointer to an array of pointers with ip addresses for the host
    Dim strAddr          As String                                  ' a address
    Dim lngAddr          As Long                                    ' a address
    Dim lngAddrPtr       As Long                                    ' a address pointer
    Dim lngErrorCode     As Long                                    ' winsock error code
    '
    Select Case uMsg                                                ' which message did we get
        Case modWinsock.lngResolveMessage                           ' host resolved message ?
            lngErrorCode = HiWord(lParam)                           ' get the error code
            '
            If lngErrorCode = 0 Then                                ' no error :)
                lngMemoryPointer = GlobalLock(lngMemoryHandle)      ' lock the memory an get a pointer to the first byte
                '
                Call CopyMemory(udtHostent, lngMemoryPointer, _
                     LenB(udtHostent))                              ' fill the hostent struct with the memory
                '
                strHostname = StrFromPtr(udtHostent.h_name)         ' get the hostname from string pointer
                strAddrType = GetAddressType(udtHostent.h_addrtype) ' get the address type
                lngAddrLength = udtHostent.h_length                 ' get the address length
                '
                Do
                    Call CopyMemory(lngAliasesPtr, udtHostent.h_aliases, 4)     ' get the pointer to the next alias name
                    If lngAliasesPtr <> 0 Then                                  ' did we get a address ?
                        lngAliasesCount = lngAliasesCount + 1                   ' increase alias count
                        ReDim Preserve strAliases(1 To lngAliasesCount)         ' redim aliases array
                        strAliases(lngAliasesCount) = StrFromPtr(lngAliasesPtr) ' get the alias from string pointer and add it to the array
                        udtHostent.h_aliases = udtHostent.h_aliases + 4         ' address for the next pointer
                    End If
                Loop While (lngAliasesPtr <> 0)                                 ' loop while we get a pointer to an alias hostname
                '
                If lngAliasesCount < 1 Then                                     ' no alias hostnames ?
                    ReDim strAliases(0 To 0)                                    ' empty alias list (ubound = 0)
                End If
                '
                If udtHostent.h_addrtype = AF_INET Then                         ' if address type is AF_INET
                    Do
                        Call CopyMemory(lngAddrListPtr, udtHostent.h_addr_list, 4)  ' get the pointer to the next ip address
                        If lngAddrListPtr <> 0 Then                                 ' did we get a address ?
                            Call CopyMemory(lngAddr, lngAddrListPtr, udtHostent.h_length) ' get the long ip addr from pointer
                            '
                            lngAddrPtr = inet_ntoa(lngAddr)                     ' get the pointer to the string ip address
                            strAddr = StrFromPtr(lngAddrPtr)                    ' get the ip address from string pointer
                            '
                            lngAddrListCount = lngAddrListCount + 1             ' increase the address count
                            ReDim Preserve strAddrList(1 To lngAddrListCount)   ' redim the address list
                            strAddrList(lngAddrListCount) = strAddr             ' add the string ip address to the array
                            udtHostent.h_addr_list = udtHostent.h_addr_list + 4 ' address for the next pointer
                        End If
                    Loop While (lngAddrListPtr <> 0)
                Else
                    lngAddrListCount = 1
                    ReDim strAddrList(1 To lngAddrListCount)
                    strAddrList(lngAddrListCount) = "Not an IP host!"
                End If
                '
                If lngAddrListCount < 1 Then                                    ' no addresses ?
                    ReDim strAddrList(0 To 0)                                   ' empty address list (ubound = 0)
                End If
                '
                'Debug.Print "udtHostent.h_name      = " & CStr(udtHostent.h_name) & " (" & strHostname & ")"
                'Debug.Print "udtHostent.h_aliases   = " & CStr(udtHostent.h_aliases) & " (" & Join(strAliases(), "; ") & ")"
                'Debug.Print "udtHostent.h_addrtype  = " & CStr(udtHostent.h_addrtype) & " (" & strAddrType & ")"
                'Debug.Print "udtHostent.h_length    = " & CStr(udtHostent.h_length)
                'Debug.Print "udtHostent.h_addr_list = " & CStr(udtHostent.h_addr_list) & " (" & Join(strAddrList(), "; ") & ")"
                'Debug.Print ""
                '
                Call GlobalUnlock(lngMemoryHandle) ' unlock the memory
                Call GlobalFree(lngMemoryHandle)   ' free the memory
                '
                RaiseEvent HostResolved(strHostname, strAliases(), strAddrType, lngAddrLength, strAddrList()) ' raise the host resolved event
            Else
                '
                Call GlobalUnlock(lngMemoryHandle) ' unlock the memory
                Call GlobalFree(lngMemoryHandle)   ' free the memory
                '
                RaiseEvent Error(lngErrorCode, GetErrorDescription(lngErrorCode), CLASS_NAME) ' raise the host resolved event
            End If
            '
            IncommingMessage = 0
        Case Else
            IncommingMessage = CallWindowProc(lngOldWindowProc, hWnd, uMsg, wParam, lParam)
    End Select
End Function

'####################################################################################################
'#####[ Helper ]#####################################################################################
'####################################################################################################
Private Function GetAddressType(ByVal lngAddrType As Long) As String
    Dim strAddrType As String
    '
    Select Case lngAddrType
        Case AF_UNSPEC:             strAddrType = "AF_UNSPEC"
        Case AF_UNIX:               strAddrType = "AF_UNIX"
        Case AF_INET:               strAddrType = "AF_INET"
        Case AF_IMPLINK:            strAddrType = "AF_IMPLINK"
        Case AF_PUP:                strAddrType = "AF_PUP"
        Case AF_CHAOS:              strAddrType = "AF_CHAOS"
        Case AF_NS:                 strAddrType = "AF_NS"
        Case AF_IPX:                strAddrType = "AF_IPX"
        Case AF_ISO:                strAddrType = "AF_ISO"
        Case AF_OSI:                strAddrType = "AF_OSI"
        Case AF_ECMA:               strAddrType = "AF_ECMA"
        Case AF_DATAKIT:            strAddrType = "AF_DATAKIT"
        Case AF_CCITT:              strAddrType = "AF_CCITT"
        Case AF_SNA:                strAddrType = "AF_SNA"
        Case AF_DECnet:             strAddrType = "AF_DECnet"
        Case AF_DLI:                strAddrType = "AF_DLI"
        Case AF_LAT:                strAddrType = "AF_LAT"
        Case AF_HYLINK:             strAddrType = "AF_HYLINK"
        Case AF_APPLETALK:          strAddrType = "AF_APPLETALK"
        Case AF_NETBIOS:            strAddrType = "AF_NETBIOS"
        Case AF_VOICEVIEW:          strAddrType = "AF_VOICEVIEW"
        Case AF_FIREFOX:            strAddrType = "AF_FIREFOX"
        Case AF_UNKNOWN1:           strAddrType = "AF_UNKNOWN1"
        Case AF_BAN:                strAddrType = "AF_BAN"
        Case AF_ATM:                strAddrType = "AF_ATM"
        Case AF_INET6:              strAddrType = "AF_INET6"
        Case AF_CLUSTER:            strAddrType = "AF_CLUSTER"
        Case AF_12844:              strAddrType = "AF_12844"
        Case Else:                  strAddrType = "Unknown"
    End Select
    '
    GetAddressType = strAddrType
End Function

Private Function GetErrorDescription(ByVal lngErrorCode As Long) As String
    Dim strDesc As String
    '
    Select Case lngErrorCode
        Case WSAEACCES:             strDesc = "Permission denied."
        Case WSAEADDRINUSE:         strDesc = "Address already in use."
        Case WSAEADDRNOTAVAIL:      strDesc = "Cannot assign requested address."
        Case WSAEAFNOSUPPORT:       strDesc = "Address family not supported by protocol family."
        Case WSAEALREADY:           strDesc = "Operation already in progress."
        Case WSAECONNABORTED:       strDesc = "Software caused connection abort."
        Case WSAECONNREFUSED:       strDesc = "Connection refused."
        Case WSAECONNRESET:         strDesc = "Connection reset by peer."
        Case WSAEDESTADDRREQ:       strDesc = "Destination address required."
        Case WSAEFAULT:             strDesc = "Bad address."
        Case WSAEHOSTDOWN:          strDesc = "Host is down."
        Case WSAEHOSTUNREACH:       strDesc = "No route to host."
        Case WSAEINPROGRESS:        strDesc = "Operation now in progress."
        Case WSAEINTR:              strDesc = "Interrupted function call."
        Case WSAEINVAL:             strDesc = "Invalid argument."
        Case WSAEISCONN:            strDesc = "Socket is already connected."
        Case WSAEMFILE:             strDesc = "Too many open files."
        Case WSAEMSGSIZE:           strDesc = "Message too long."
        Case WSAENETDOWN:           strDesc = "Network is down."
        Case WSAENETRESET:          strDesc = "Network dropped connection on reset."
        Case WSAENETUNREACH:        strDesc = "Network is unreachable."
        Case WSAENOBUFS:            strDesc = "No buffer space available."
        Case WSAENOPROTOOPT:        strDesc = "Bad protocol option."
        Case WSAENOTCONN:           strDesc = "Socket is not connected."
        Case WSAENOTSOCK:           strDesc = "Socket operation on nonsocket."
        Case WSAEOPNOTSUPP:         strDesc = "Operation not supported."
        Case WSAEPFNOSUPPORT:       strDesc = "Protocol family not supported."
        Case WSAEPROCLIM:           strDesc = "Too many processes."
        Case WSAEPROTONOSUPPORT:    strDesc = "Protocol not supported."
        Case WSAEPROTOTYPE:         strDesc = "Protocol wrong type for socket."
        Case WSAESHUTDOWN:          strDesc = "Cannot send after socket shutdown."
        Case WSAESOCKTNOSUPPORT:    strDesc = "Socket type not supported."
        Case WSAETIMEDOUT:          strDesc = "Connection timed out."
        Case WSATYPE_NOT_FOUND:     strDesc = "Class type not found."
        Case WSAEWOULDBLOCK:        strDesc = "Resource temporarily unavailable."
        Case WSAHOST_NOT_FOUND:     strDesc = "Host not found."
        Case WSANOTINITIALISED:     strDesc = "Successful WSAStartup not yet performed."
        Case WSANO_DATA:            strDesc = "Valid name, no data record of requested type."
        Case WSANO_RECOVERY:        strDesc = "This is a nonrecoverable error."
        Case WSASYSCALLFAILURE:     strDesc = "System call failure."
        Case WSASYSNOTREADY:        strDesc = "Network subsystem is unavailable."
        Case WSATRY_AGAIN:          strDesc = "Nonauthoritative host not found."
        Case WSAVERNOTSUPPORTED:    strDesc = "Winsock.dll version out of range."
        Case WSAEDISCON:            strDesc = "Graceful shutdown in progress."
        Case Else:                  strDesc = "Unknown error."
    End Select
    '
    GetErrorDescription = strDesc
End Function

Private Function StrFromPtr(ptr As Long) As String
    Dim sBuff As String
    Dim lSize As Long
    Dim lRet  As Long
    '
    lSize = lstrlen(ptr)
    '
    If lSize > 0 Then
        sBuff = String$(lSize, vbNullChar)
        '
        lRet = lstrcpy(sBuff, ptr)
        '
        If lRet <> 0 Then
            StrFromPtr = sBuff
        End If
    End If
End Function

Private Function StripNull(sData As String)
    Dim lPos As Long
    '
    lPos = InStr(sData, vbNullChar)
    '
    If lPos > 0 Then
        StripNull = Left$(sData, lPos - 1)
    Else
        StripNull = sData
    End If
End Function

Private Function LoWord(lngValue As Long) As Long
   LoWord = (lngValue And &HFFFF&)
End Function

Private Function HiWord(lngValue As Long) As Long
    If (lngValue And &H80000000) = &H80000000 Then
        HiWord = ((lngValue And &H7FFF0000) \ &H10000) Or &H8000&
    Else
        HiWord = (lngValue And &HFFFF0000) \ &H10000
    End If
End Function

Private Function LoByte(ByVal wParam As Integer)
    LoByte = wParam And &HFF
End Function

Private Function HiByte(ByVal wParam As Integer)
    'HiByte = wParam \ &H100 And &HFF&
    HiByte = (wParam And &HFF00) / &H100
End Function
